//creates a cache of the specified size
function Cache(size)
{
    this.cacheItems = new Array(size);
    this.size = size;
    this.n = 0;
    
    //cache an object under the specified key, which will expire after lifespan seconds
    function insert(object, key, lifespan)
    {
        var item = new CacheItem(object, key, time() + lifespan*1000)
        
        if(this.n < size)
            this.cacheItems[this.n++] = item;
        else
            this.cacheItems[this.oldest()] = item;
    }

    //returns the cached object if found (and not expired), null otherwise
    function lookup(key)
    {
        var currTime = time();
        
        for(var i = 0; i < this.n; i++)
        {
            if(this.cacheItems[i])
            {
            	if(this.cacheItems[i].key == key && this.cacheItems[i].expires > currTime)
                	return this.cacheItems[i].obj;
        	}
        }
        return null;
    }

    //returns the index of the next item in the cache to expire (for replacement)
    function oldest()
    {
        var lowTTL = 9999999999;
        var index = 0;
    
        for(var i = 0; i < this.n; i++)
        {
            TTL = time() - this.cacheItems[i].expires;
            if(TTL < lowTTL)
            {
                lowTTL = TTL;
                index = i;
            }
        }
        return index;
    }
    
    //a boolean
    function isCached(key)
    {
        return (lookup(key) == null) ? false : true;
    }
    
    this.insert = insert;
    this.lookup = lookup;
    this.oldest = oldest;
    this.isCached = isCached;
}

//the object stored in the cache
function CacheItem(object, key, expires)
{
    this.obj = object;
    this.key = key;
    this.expires = expires;
}

//returns the epoch time
function time()
{
    return (new Date()).getTime();
}
