var openRequest = null;
var stationListCache = new Cache(3);


function performQuery()
{
	//update graphics
	spinPrice();
	rankShown = 1;
	document.getElementById("rankDown").style.display = 'none';
	document.getElementById("rankUp").style.display = 'block';
	
	//prepare query
	zipcode = document.getElementById("zipcode").value;
	radius = document.getElementById("radius").value;
	sortnum = document.getElementById("sortnum").value;
	sort = (multigrade) ? "A" : gradeList[sortnum].toUpperCase(); 
	
	cacheID = zipcode + "." + radius + "." + sort;
	
	//check the cache
	stationList = stationListCache.lookup(cacheID);
	
	if(stationList)
	{
		//alert("Cache hit: " + cacheID);
		stationList[rankShown-1].display();  // update the display
		return;
	}

	//query the data...
	if(openRequest) openRequest.abort();

	openRequest = new XMLHttpRequest();
	openRequest.open("POST", "http://gaspricewatch.com/IDM/zr.asp", true);
    openRequest.onreadystatechange = receiveResponse;
    openRequest.send("Z=" + zipcode + "&R=" + radius + "&G=" + sort);
}

function receiveResponse()
{
    //check for a completed request
	if(openRequest.readyState == 4)
	{
		if(openRequest.status == 200)
			parseResults(openRequest.responseText);
		else
		{
			//display no results found
			parseResults("");
		}
	}
}

function parseResults(HTML)
{   
    stationResults = HTML.split("\n");
    stationResults = stationResults.slice(1,-2);
    
    //Handle empty results list
    if(stationResults.length == 0)
    {
    	station = new Station(1, "No results found.", "Please try broadening", "your search options.");
    	if($("multibox").checked){
    		for(i=0;i<4;i++)
    			station.setPriceForGrade(gradeList[i], ["n","s","p"], -1);
    	}else{
    		station.setPriceForGrade(grade, ["n","s","p"], -1);
    	}
    	rankShown = 1;
    	maxRank = 1;
    	stationList = new Array(1);
    	stationList[0] = station;
    	document.getElementById("rankUp").style.display = 'none';
    }
    else
    {
    	maxRank = Math.min(stationResults.length, 9);
		rankShown = Math.min(maxRank, rankShown);
		stationList = new Array(maxRank);
		var station;
		
		for(var i = 0; i < maxRank; i++){
		
	        stationInfo = stationResults[i].split("|");
   			
   			if(multiviewing)
			{
				var re = stationInfo[0].split('');
				var pl = stationInfo[1].split('');
				var pr = stationInfo[2].split('');
				var di = stationInfo[3].split('');
				var name = stationInfo[4];
				var addr1 = stationInfo[5];
				var addr2 = stationInfo[6] + ", " + stationInfo[7];
				
				station = new Station(i+1, name, addr1, addr2);
			
				if(re.length > 0) station.setPriceForGrade("regular", [re[0], re[1], re[2]], re[3] + ((re.length == 5) ? re[4] : ''));
				else   station.setPriceForGrade("regular", ["n","s","p"], -1);
				
				if(pl.length > 0) station.setPriceForGrade("plus",    [pl[0], pl[1], pl[2]], pl[3] + ((pl.length == 5) ? pl[4] : ''));
				else   station.setPriceForGrade("plus",    ["n","s","p"], -1);
				
				if(pr.length > 0) station.setPriceForGrade("premium", [pr[0], pr[1], pr[2]], pr[3] + ((pr.length == 5) ? pr[4] : ''));
				else   station.setPriceForGrade("premium", ["n","s","p"], -1);
				
				if(di.length > 0) station.setPriceForGrade("diesel",  [di[0], di[1], di[2]], di[3] + ((di.length == 5) ? di[4] : ''));
				else   station.setPriceForGrade("diesel",  ["n","s","p"], -1);
			}
			else 
			{
				var end = (stationInfo.length);
				
				var g = stationInfo[0].split('');
				var name = stationInfo[end-4];
				var addr1 = stationInfo[end-3];
				var addr2 = stationInfo[end-2] + ", " + stationInfo[end-1];
				
				station = new Station(i+1, name, addr1, addr2);
				
				if(g.length > 0) station.setPriceForGrade(gradeList[$('sortnum').selectedIndex-1], [g[0], g[1], g[2]], g[3] + ((g.length == 5) ? g[4] : ''));
				else   station.setPriceForGrade(gradeList[$('sortnum').selectedIndex-1], ["n","s","p"], -1);
			}
			
			stationList[i] = station;
		}
		stationListCache.insert(stationList, cacheID, 1800);
    }
    
    setGauge($('gas_slider').value/100);
    sortStations(gradeList[$("sortnum").selectedIndex - 1]);
    stationList[rankShown-1].display();  //update the dsiplay for the current station...   
}

